import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import { attr, createSelector as createOrmSelector, fk, many, Model, ORM } from "./";

var Book = /*#__PURE__*/function (_Model) {
  _inheritsLoose(Book, _Model);

  function Book() {
    return _Model.apply(this, arguments) || this;
  }

  Book.reducer = function reducer(action, _Book) {
    switch (action.type) {
      case "CREATE_BOOK":
        _Book.create(action.payload);

        break;

      case "DELETE_BOOK":
        _Book.filter(function (book) {
          return book.title === action.payload.title;
        })["delete"]();

        break;

      default:
        break;
    }
  };

  return Book;
}(Model);

_defineProperty(Book, "modelName", "Book");

_defineProperty(Book, "fields", {
  title: attr(),
  coverArt: attr({
    getDefault: function getDefault() {
      return "empty.png";
    }
  }),
  publisher: fk("Publisher", "books"),
  authors: many({
    to: "Person",
    relatedName: "books",
    through: "Authorship"
  })
});

_defineProperty(Book, "options", {
  idAttribute: "title"
});

var Person = /*#__PURE__*/function (_Model2) {
  _inheritsLoose(Person, _Model2);

  function Person() {
    return _Model2.apply(this, arguments) || this;
  }

  return Person;
}(Model);

_defineProperty(Person, "modelName", "Person");

_defineProperty(Person, "fields", {
  id: attr(),
  firstName: attr(),
  lastName: attr(),
  nationality: attr()
});

var Authorship = /*#__PURE__*/function (_Model3) {
  _inheritsLoose(Authorship, _Model3);

  function Authorship() {
    return _Model3.apply(this, arguments) || this;
  }

  return Authorship;
}(Model);

_defineProperty(Authorship, "modelName", "Authorship");

_defineProperty(Authorship, "fields", {
  year: attr(),
  book: fk("Book"),
  author: fk("Person")
});

var Publisher = /*#__PURE__*/function (_Model4) {
  _inheritsLoose(Publisher, _Model4);

  function Publisher() {
    return _Model4.apply(this, arguments) || this;
  }

  return Publisher;
}(Model);

_defineProperty(Publisher, "modelName", "Publisher");

_defineProperty(Publisher, "fields", {
  index: attr(),
  name: attr()
});

_defineProperty(Publisher, "options", {
  idAttribute: "index"
});

var schema = {
  Book: Book,
  Authorship: Authorship,
  Person: Person,
  Publisher: Publisher
};

// create ORM instance and register { Book, Publisher, Person, Authorship } schema
var ormFixture = function ormFixture() {
  var orm = new ORM({
    stateSelector: function stateSelector(state) {
      return state.db;
    }
  });
  orm.register(Book, Authorship, Person, Publisher);
  return orm;
}; // create ORM instance and acquire new session


var sessionFixture = function sessionFixture() {
  var orm = ormFixture();
  return orm.session(orm.getEmptyState());
}; // argOptionalityAtModelCreation - inferred optionality of ModelType.create argument properties


(function () {
  var _sessionFixture = sessionFixture(),
      Book = _sessionFixture.Book,
      Publisher = _sessionFixture.Publisher;
  /**
   * 1.A. `number` Model identifiers are optional due to built-in incremental sequencing of numeric identifiers
   * @see {@link PublisherFields.index}
   */


  Publisher.create({
    name: "P1"
  });
  /**
   * 1.B. `string` identifiers are mandatory
   */

  Book.create({
    publisher: 1,
    coverArt: "foo.bmp"
  }); // $ExpectError

  /**
   * 2. non-relational fields with corresponding descriptors that contain defined `getDefault` callback: (`attr({ getDefault: () => 'empty.png' })`)
   * @see {@link Book#fields.coverArt}
   */

  Book.create({
    title: "B2",
    publisher: 1
  });
  /**
   * 3. both attribute and relational fields where corresponding ModelFields interface property has optional (`?`) modifier
   * @see {@link BookFields.authors}
   */

  Book.create({
    title: "B1",
    publisher: 1,
    coverArt: "foo.bmp"
  });
})(); // argPropertyTypeRestrictionsOnCreate - ModelFields contribute to type constraints within ModelType.create arguments


(function () {
  var _sessionFixture2 = sessionFixture(),
      Book = _sessionFixture2.Book,
      Publisher = _sessionFixture2.Publisher,
      Person = _sessionFixture2.Person;
  /** Keys of declared model fields interface contribute strict requirements regarding corresponding property types */


  Book.create({
    title: "B1",
    publisher: 1,
    coverArt: "foo.png",
    authors: ["A1"]
  });
  /* Incompatible property types: */

  Book.create({
    title: 1,
    publisher: 1
  }); // $ExpectError

  Book.create({
    title: "B1",
    publisher: "P1"
  }); // $ExpectError

  Book.create({
    title: "B1",
    publisher: 1,
    coverArt: 4
  }); // $ExpectError

  Book.create({
    title: "B1",
    publisher: 1,
    authors: {}
  }); // $ExpectError

  Book.create({
    title: "B1",
    publisher: 1,
    authors: function authors() {
      return null;
    }
  }); // $ExpectError

  /**
   * Properties associated to relational fields may be supplied with:
   *
   * - a primitive type matching id type of relation target
   * - Model/SessionBoundModel instance matching relation target
   *
   * In case of MutableQuerySets/many-to-many relationships, an array of union of above-mentioned types is accepted
   */

  var authorModel = Person.create({
    id: "A1",
    firstName: "A1",
    lastName: "A1"
  });
  var publisherModel = Publisher.create({
    name: "P1"
  });
  Book.create({
    title: "B1",
    publisher: publisherModel,
    authors: [authorModel]
  });
  Book.create({
    title: "B1",
    publisher: publisherModel.index,
    authors: [authorModel, "A1", authorModel, authorModel.ref.id]
  });
  /** Id types are verified to match relation target */

  Book.create({
    title: "B1",
    publisher: authorModel
  }); // $ExpectError

  Book.create({
    title: "B1",
    publisher: publisherModel.ref,
    authors: [publisherModel.ref, "A1"]
  }); // $ExpectError

  Book.create({
    title: "B1",
    publisher: {
      index: "P1 "
    }
  }); // $ExpectError

  Book.create({
    title: "B1",
    publisher: {
      index: 0
    },
    authors: [authorModel, true]
  }); // $ExpectError
})(); // argPropertyTypeRestrictionsOnUpsert - ModelFields contribute to type constraints within ModelType.create arguments


(function () {
  var _sessionFixture3 = sessionFixture(),
      Book = _sessionFixture3.Book,
      Publisher = _sessionFixture3.Publisher,
      Person = _sessionFixture3.Person;
  /** Upsert requires id to be provided */


  Book.upsert({
    publisher: 1
  }); // $ExpectError
  // $ExpectType SessionBoundModel<Book, Pick<{ title: string; publisher: number; }, never>> || SessionBoundModel<Book, CustomInstanceProps<Book, { title: string; publisher: number; }>>

  Book.upsert({
    title: "B1",
    publisher: 1
  });
  /* Incompatible property types: */

  Book.upsert({
    title: 4,
    publisher: "P1"
  }); // $ExpectError

  Book.upsert({
    title: "B1",
    publisher: "P1"
  }); // $ExpectError

  Book.upsert({
    title: "B1",
    publisher: 1,
    coverArt: 4
  }); // $ExpectError

  Book.upsert({
    title: "B1",
    publisher: 1,
    authors: {}
  }); // $ExpectError

  Book.upsert({
    title: "B1",
    publisher: 1,
    authors: function authors() {
      return null;
    }
  }); // $ExpectError

  /**
   * Properties associated to relational fields may be supplied with:
   *
   * - a primitive type matching id type of relation target
   * - a Ref type derived from relation target
   * - Model/SessionBoundModel instance matching relation target
   * - a map containing {Idkey:IdType} entry, where IdKey/IdType are compatible with relation target id key:type signature
   *
   * In case of MutableQuerySets/many-to-many relationships, an array of union of above-mentioned types is accepted
   */

  var authorModel = Person.upsert({
    id: "A1",
    firstName: "A1",
    lastName: "A1"
  });
  var publisherModel = Publisher.upsert({
    name: "P1",
    index: 1
  });
  Book.upsert({
    title: "B1",
    publisher: 1,
    authors: [authorModel]
  });
  Book.upsert({
    title: "B1",
    publisher: publisherModel,
    authors: [authorModel]
  });
  /** Id types are verified to match relation target */

  Book.create({
    title: "B1",
    publisher: authorModel
  }); // $ExpectError

  Book.create({
    title: "B1",
    publisher: publisherModel.ref,
    authors: [publisherModel.ref, "A1"]
  }); // $ExpectError

  Book.create({
    title: "B1",
    publisher: {
      index: "P1 "
    }
  }); // $ExpectError

  Book.create({
    title: "B1",
    publisher: {
      index: 0
    },
    authors: [authorModel, true]
  }); // $ExpectError
})(); // restriction of allowed ORM.register args


(function () {
  var incompleteSchema = {
    Book: Book,
    Authorship: Authorship,
    Person: Person
  };
  var orm = new ORM();
  orm.register(Book, Authorship, Person, Publisher); // $ExpectError
})(); // inference of ORM branch state type


(function () {
  var emptyState = ormFixture().getEmptyState();
  var bookTableState = emptyState.Book; // $ExpectType TableState<typeof Book>

  var bookItemsById = emptyState.Book.itemsById; // $ExpectType { readonly [K: string]: Ref<Book>; }

  var authorshipMetaState = emptyState.Authorship.meta.maxId; // $ExpectType number

  var bookMetaState = emptyState.Book.meta.maxId; // $ExpectType number | null
})(); // sessionInstanceExtendedWithNarrowedModelClasses - indexing session instance using registered Model.modelName returns narrowed Model class


(function () {
  var _sessionFixture4 = sessionFixture(),
      Book = _sessionFixture4.Book,
      Person = _sessionFixture4.Person,
      Publisher = _sessionFixture4.Publisher; // $ExpectType { Book: ModelType<Book>; Person: ModelType<Person>; Publisher: ModelType<Publisher>; }


  var sessionBoundModels = {
    Book: Book,
    Person: Person,
    Publisher: Publisher
  };
  return _objectSpread({}, sessionBoundModels);
})(); // IdKey and IdType mapped types support for valid identifier configurations


(function () {})(); // Model#create result retains custom properties supplied during call


(function () {
  var _sessionFixture5 = sessionFixture(),
      Book = _sessionFixture5.Book;

  var basicBook = Book.create({
    title: "book",
    publisher: 1
  });
  // $ExpectType "title" | "coverArt" | "publisher" | "authors" || keyof BookFields
  var basicBookTitle = basicBook.title; // $ExpectType string

  var authors = basicBook.authors; // $ExpectType MutableQuerySet<Person, {}>

  var unknownPropertyError = basicBook.customProp; // $ExpectError

  var customProp = {
    foo: 0,
    bar: true
  };
  var extendedBook = Book.create({
    title: "extendedBook",
    publisher: 1,
    customProp: customProp
  });
  // $ExpectType "title" | "coverArt" | "publisher" | "authors" | "customProp" || keyof BookFields | "customProp"
  var extendedBookTitle = extendedBook.title; // $ExpectType string

  var instanceCustomProp = extendedBook.customProp; // $ExpectType { foo: number; bar: boolean; }
})(); // reducer API is intact


(function () {
  var orm = ormFixture();
  return function (state, action) {
    var session = orm.session(state);
    session.Book.create(action.payload);
    return session.state;
  };
})(); // QuerySet type is retained though query chain until terminated.
// Orders are optional, must conform to SortOrder type when present.
// QuerySet.orderBy overloads accept iteratees applicable to QuerySet's type only
// orderByArguments


(function () {
  var _sessionFixture6 = sessionFixture(),
      Book = _sessionFixture6.Book;

  var booksQuerySet = Book.all(); // $ExpectType readonly Ref<Book>[]

  booksQuerySet.orderBy("title").orderBy(function (book) {
    return book.publisher;
  }, "desc").orderBy(function (book) {
    return book.title;
  }, false).orderBy("publisher", "asc").orderBy("publisher", true).toRefArray(); // $ExpectType readonly Ref<Book>[]

  booksQuerySet.orderBy(["title"], ["asc"]).orderBy(["publisher", "title"], [true, "desc"]).orderBy([function (book) {
    return book.title;
  }], ["desc"]).orderBy(["title"]).orderBy([function (book) {
    return book.title;
  }, "publisher"], ["desc", false]).toRefArray();
  booksQuerySet.orderBy("notABookPropertyKey"); // $ExpectError

  booksQuerySet.orderBy([function (book) {
    return book.notABookPropertyKey;
  }], false); // $ExpectError

  booksQuerySet.orderBy("title", "inc"); // $ExpectError

  booksQuerySet.orderBy("title", 4); // $ExpectError

  booksQuerySet.orderBy(["notABookPropertyKey"]); // $ExpectError

  booksQuerySet.orderBy([function (book) {
    return book.notABookPropertyKey;
  }]); // $ExpectError

  booksQuerySet.orderBy(["title"], ["inc"]); // $ExpectError

  booksQuerySet.orderBy(["title"], [4]); // $ExpectError
})(); // selectors


(function () {
  // test fixture, use reselect.createSelector in production code
  var createSelector = function createSelector(param1Creator, combiner) {
    return function (state) {
      return combiner(param1Creator(state));
    };
  };

  var orm = ormFixture();
  var ormSelector = createOrmSelector(orm, function (session) {
    return session.Book.all().toRefArray()[0];
  });
  var selector = createSelector(function (_ref) {
    var db = _ref.db;
    return db;
  }, ormSelector);
  createSelector(function (_ref2) {
    var db = _ref2.db;
    return db;
  }, ormSelector // $ExpectError
  );
  selector({
    db: orm.getEmptyState()
  }); // $ExpectType Ref<Book>
})(); // advanced selectors


(function () {
  var orm = ormFixture();
  var selector0 = createOrmSelector(orm, function (s) {
    return s.db;
  }, function (session) {
    return session.Book.first().ref;
  });
  var selector1 = createOrmSelector(orm, function (s) {
    return s.db;
  }, function (s) {
    return s.bar;
  }, function (session, title) {
    return session.Book.get({
      title: title
    }).ref;
  });
  var selector2 = createOrmSelector(orm, function (s) {
    return s.db;
  }, function (s) {
    return s.foo;
  }, function (s) {
    return s.bar;
  }, function (session, id, title) {
    return session.Book.get({
      id: id,
      title: title
    }).ref;
  });
  var selector3 = createOrmSelector(orm, function (s) {
    return s.db;
  }, function (s) {
    return s.foo;
  }, function (s) {
    return s.bar;
  }, function (s) {
    return s.foo;
  }, function (session, id, title, id2) {
    return session.Book.get({
      id: id,
      title: title,
      id2: id2
    }).ref;
  });
  var selector4 = createOrmSelector(orm, function (s) {
    return s.db;
  }, function (s) {
    return s.foo;
  }, function (s) {
    return s.bar;
  }, function (s) {
    return s.foo;
  }, function (s) {
    return s.bar;
  }, function (session, id, title, id2, title2) {
    return session.Book.get({
      id: id,
      title: title,
      id2: id2,
      title2: title2
    }).ref;
  });
  var selector5 = createOrmSelector(orm, function (s) {
    return s.db;
  }, function (s) {
    return s.foo;
  }, function (s) {
    return s.bar;
  }, function (s) {
    return s.foo;
  }, function (s) {
    return s.bar;
  }, function (s) {
    return s.foo;
  }, function (session) {
    return session.Book.get({
      title: arguments.length <= 2 ? undefined : arguments[2]
    }).ref;
  });
  var selector6 = createOrmSelector(orm, function (s) {
    return s.db;
  }, function (s) {
    return s.foo;
  }, function (s) {
    return s.bar;
  }, function (s) {
    return s.foo;
  }, function (s) {
    return s.bar;
  }, function (s) {
    return s.foo;
  }, function (s) {
    return s.bar;
  }, function (session, id, title) {
    return session.Book.get({
      title: title
    }).ref;
  });
  var invalidSelector = createOrmSelector(orm, function (s) {
    return s.db;
  }, function (s) {
    return s.foo;
  }, function (session, foo, missingArg) {
    return foo;
  } // $ExpectError
  );
  var invalidSelector2 = createOrmSelector(orm, function (s) {
    return s.db;
  }, function (s) {
    return s.foo;
  }, function (session, foo) {
    return session.Book.withId(foo).ref;
  } // $ExpectError
  );
  var state = {
    db: orm.getEmptyState(),
    foo: 1,
    bar: "foo"
  };
  selector0(state); // $ExpectType Ref<Book>

  selector1(state); // $ExpectType Ref<Book>

  selector2(state); // $ExpectType Ref<Book>

  selector3(state); // $ExpectType Ref<Book>

  selector4(state); // $ExpectType Ref<Book>

  selector5(state); // $ExpectType Ref<Book>

  selector6(state); // $ExpectType Ref<Book>
})(); // redux-orm-types#7


(function () {
  var _sessionFixture7 = sessionFixture(),
      Book = _sessionFixture7.Book;

  Book.exists({
    title: "foo"
  });
  Book.all().exists();
  Book.exists(); // $ExpectError

  Book.exists("foo"); // $ExpectError

  Book.all().exists({}); // $ExpectError
})(); // redux-orm-types#8


(function () {
  var _sessionFixture8 = sessionFixture(),
      Book = _sessionFixture8.Book;

  Book.all().toModelArray();
  Book.all().toRefArray();
  Book.toModelArray(); // $ExpectError

  Book.toRefArray(); // $ExpectError
})(); // redux-orm-types#9


(function () {
  var _sessionFixture9 = sessionFixture(),
      Book = _sessionFixture9.Book,
      Person = _sessionFixture9.Person,
      Publisher = _sessionFixture9.Publisher;

  var author = Person.create({
    id: "1",
    firstName: "foo",
    lastName: "bar",
    nationality: "pl"
  });
  var publisher = Publisher.create({
    name: "foo"
  });
  Book.create({
    title: "foo",
    publisher: 1
  });
  Book.create({
    title: "foo",
    publisher: 1,
    coverArt: "bar"
  });
  Book.create({
    title: "foo",
    publisher: publisher,
    coverArt: "bar",
    authors: ["foo", author]
  });
  Book.create({
    title: "foo",
    publisher: author
  }); // $ExpectError

  Book.create({
    title: "foo",
    publisher: "error"
  }); // $ExpectError

  Book.create({
    title: "foo",
    publisher: publisher,
    coverArt: "bar",
    authors: [3, author]
  }); // $ExpectError
})(); // redux-orm-types#18


(function () {
  return many({
    to: "Bar",
    relatedName: "foos",
    through: "FooBar",
    throughFields: ["foo", "bar"]
  });
})();