import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _createClass from "@babel/runtime/helpers/createClass";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import ModelBasedSelectorSpec from "./ModelBasedSelectorSpec";

var MapSelectorSpec = /*#__PURE__*/function (_ModelBasedSelectorSp) {
  _inheritsLoose(MapSelectorSpec, _ModelBasedSelectorSp);

  function MapSelectorSpec(_ref) {
    var _this;

    var field = _ref.field,
        selector = _ref.selector,
        other = _objectWithoutProperties(_ref, ["field", "selector"]);

    _this = _ModelBasedSelectorSp.call(this, other) || this;
    _this._field = field;
    _this._selector = selector;
    return _this;
  }
  /** Result for createSelectorFromSpec, not createSelectorFromSpecFor! */


  var _proto = MapSelectorSpec.prototype;

  _proto.createResultFunc = function createResultFunc(parentSelector) {
    return function mapSelectorResult(state, _session, idArg) {
      var _this2 = this;

      /**
       * The parent selector should return a ref array
       * in case of a single ID being passed.
       * Otherwise it should return an array of ref arrays.
       */
      var parentResult = parentSelector(state, idArg);

      if (parentResult === null) {
        return null;
      }

      if (typeof idArg === "undefined" || Array.isArray(idArg)) {
        return parentResult.map(function (refArray) {
          return refArray === null ? null : refArray.map(function (ref) {
            return ref === null ? null : _this2.valueForRef(ref, null, state);
          });
        });
      }

      return parentResult.map(function (ref) {
        return _this2.valueForRef(ref, null, state);
      });
    };
  };

  _proto.valueForRef = function valueForRef(ref, _session, state) {
    var idAttribute = this._parent.toModel.idAttribute;
    return this._selector(state, ref[idAttribute]);
  };

  _createClass(MapSelectorSpec, [{
    key: "selector",
    get: function get() {
      return this._selector;
    },
    set: function set(selector) {
      this._selector = selector;
    }
  }, {
    key: "key",
    get: function get() {
      return this._selector;
    }
  }]);

  return MapSelectorSpec;
}(ModelBasedSelectorSpec);

export { MapSelectorSpec as default };