import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _createClass from "@babel/runtime/helpers/createClass";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import SelectorSpec from "./SelectorSpec";
import idArgSelector from "./idArgSelector";
/**
 * @abstract
 */

var ModelBasedSelectorSpec = /*#__PURE__*/function (_SelectorSpec) {
  _inheritsLoose(ModelBasedSelectorSpec, _SelectorSpec);

  function ModelBasedSelectorSpec(_ref) {
    var _this;

    var model = _ref.model,
        other = _objectWithoutProperties(_ref, ["model"]);

    _this = _SelectorSpec.call(this, other) || this;
    _this._model = model;
    return _this;
  }

  var _proto = ModelBasedSelectorSpec.prototype;

  /** @abstract */
  _proto.valueForInstance = function valueForInstance(_instance, _session, _state) {
    throw new Error("Not implemented");
  };

  _proto.valueForRef = function valueForRef(ref, session, state) {
    var ModelClass = session[this._model.modelName];
    return this.valueForInstance(ModelClass.withId(ref[ModelClass.idAttribute]), session, state);
  };

  _proto.modelIs = function modelIs(modelName) {
    return modelName === this._model.modelName;
  };

  _createClass(ModelBasedSelectorSpec, [{
    key: "dependencies",
    get: function get() {
      return [function (state) {
        return state;
      }, this._orm, idArgSelector];
    }
  }, {
    key: "resultFunc",
    get: function get() {
      return function modelBasedSelectorResult(state, session, idArg) {
        var _this2 = this;

        var ModelClass = session[this._model.modelName];

        if (typeof idArg === "undefined") {
          return ModelClass.all().toModelArray().map(function (instance) {
            return _this2.valueForInstance(instance, session, state);
          });
        }

        if (Array.isArray(idArg)) {
          return idArg.map(function (id) {
            return _this2.valueForInstance(ModelClass.withId(id), session, state);
          });
        }

        return this.valueForInstance(ModelClass.withId(idArg), session, state);
      };
    }
  }, {
    key: "model",
    get: function get() {
      return this._model;
    }
  }]);

  return ModelBasedSelectorSpec;
}(SelectorSpec);

export { ModelBasedSelectorSpec as default };