"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _SelectorSpec2 = _interopRequireDefault(require("./SelectorSpec"));

var _idArgSelector = _interopRequireDefault(require("./idArgSelector"));

/**
 * @abstract
 */
var ModelBasedSelectorSpec = /*#__PURE__*/function (_SelectorSpec) {
  (0, _inheritsLoose2["default"])(ModelBasedSelectorSpec, _SelectorSpec);

  function ModelBasedSelectorSpec(_ref) {
    var _this;

    var model = _ref.model,
        other = (0, _objectWithoutProperties2["default"])(_ref, ["model"]);
    _this = _SelectorSpec.call(this, other) || this;
    _this._model = model;
    return _this;
  }

  var _proto = ModelBasedSelectorSpec.prototype;

  /** @abstract */
  _proto.valueForInstance = function valueForInstance(_instance, _session, _state) {
    throw new Error("Not implemented");
  };

  _proto.valueForRef = function valueForRef(ref, session, state) {
    var ModelClass = session[this._model.modelName];
    return this.valueForInstance(ModelClass.withId(ref[ModelClass.idAttribute]), session, state);
  };

  _proto.modelIs = function modelIs(modelName) {
    return modelName === this._model.modelName;
  };

  (0, _createClass2["default"])(ModelBasedSelectorSpec, [{
    key: "dependencies",
    get: function get() {
      return [function (state) {
        return state;
      }, this._orm, _idArgSelector["default"]];
    }
  }, {
    key: "resultFunc",
    get: function get() {
      return function modelBasedSelectorResult(state, session, idArg) {
        var _this2 = this;

        var ModelClass = session[this._model.modelName];

        if (typeof idArg === "undefined") {
          return ModelClass.all().toModelArray().map(function (instance) {
            return _this2.valueForInstance(instance, session, state);
          });
        }

        if (Array.isArray(idArg)) {
          return idArg.map(function (id) {
            return _this2.valueForInstance(ModelClass.withId(id), session, state);
          });
        }

        return this.valueForInstance(ModelClass.withId(idArg), session, state);
      };
    }
  }, {
    key: "model",
    get: function get() {
      return this._model;
    }
  }]);
  return ModelBasedSelectorSpec;
}(_SelectorSpec2["default"]);

exports["default"] = ModelBasedSelectorSpec;