"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _SelectorSpec2 = _interopRequireDefault(require("./SelectorSpec"));

var _idArgSelector = _interopRequireDefault(require("./idArgSelector"));

var ModelSelectorSpec = /*#__PURE__*/function (_SelectorSpec) {
  (0, _inheritsLoose2["default"])(ModelSelectorSpec, _SelectorSpec);

  function ModelSelectorSpec(_ref) {
    var _this;

    var model = _ref.model,
        other = (0, _objectWithoutProperties2["default"])(_ref, ["model"]);
    _this = _SelectorSpec.call(this, other) || this;
    _this._model = model;
    return _this;
  }

  var _proto = ModelSelectorSpec.prototype;

  _proto.valueForRef = function valueForRef(ref, _session) {
    return ref;
  };

  _proto.modelIs = function modelIs(modelName) {
    return modelName === this._model.modelName;
  };

  (0, _createClass2["default"])(ModelSelectorSpec, [{
    key: "key",
    get: function get() {
      return this._model.modelName;
    }
  }, {
    key: "dependencies",
    get: function get() {
      return [function (state) {
        return state;
      }, this._orm, _idArgSelector["default"]];
    }
  }, {
    key: "resultFunc",
    get: function get() {
      return function modelSelectorResult(_state, session, idArg) {
        var ModelClass = session[this._model.modelName];

        if (typeof idArg === "undefined") {
          return ModelClass.all().toRefArray();
        }

        if (Array.isArray(idArg)) {
          return idArg.map(function (id) {
            var instance = ModelClass.withId(id);
            return instance ? instance.ref : null;
          });
        }

        var instance = ModelClass.withId(idArg);
        return instance ? instance.ref : null;
      };
    }
  }, {
    key: "model",
    get: function get() {
      return this._model;
    }
  }]);
  return ModelSelectorSpec;
}(_SelectorSpec2["default"]);

exports["default"] = ModelSelectorSpec;