"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.ORM = void 0;

/**
 * A `{typeof Model[modelName]: typeof Model}` map defining:
 *
 * - database schema
 * - {@link Session} bound Model classes
 * - ORM branch state type
 */

/**
 * A mapped type capable of inferring ORM branch state type based on schema {@link Model}s.
 */

/**
 * ORM instantiation opts.
 *
 * Enables customization of database creation.
 */

/**
 * ORM - the Object Relational Mapper.
 *
 * Use instances of this class to:
 *
 * - Register your {@link Model} classes using {@link ORM#register}
 * - Get the empty state for the underlying database with {@link ORM#getEmptyState}
 * - Start an immutable database session with {@link ORM#session}
 * - Start a mutating database session with {@link ORM#mutableSession}
 *
 * Internally, this class handles generating a schema specification from models
 * to the database.
 */
var ORM = /*#__PURE__*/function () {
  return ORM;
}();

exports.ORM = ORM;
var _default = ORM;
exports["default"] = _default;