"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Table = void 0;

/**
 * {@link TableOpts} used for {@link Table} customization.
 *
 * Supplied via {@link Model#options}.
 *
 * If no customizations were provided, the table uses following default options:
 * <br/>
 * ```typescript
 *  {
 *      idAttribute: 'id',
 *      arrName:     'items',
 *      mapName:     'itemsById'
 *  }
 * ```
 * <br/>
 *  @see {@link Model}
 *  @see {@link Model#options}
 *  @see {@link OrmState}
 */

/**
 * @internal
 */

/**
 * Model idAttribute option extraction helper.
 *
 * Falls back to `'id'` if not specified explicitly via {@link Model.options}.
 */

/**
 * Model arrName option extraction helper.
 *
 * Falls back to `'items'` if not specified explicitly via {@link Model.options}.
 */

/**
 * Model mapName option extraction helper.
 *
 * Falls back to `'itemsById'` if not specified explicitly via {@link Model.options}.
 */

/**
 * Unbox {@link Model#options} or fallback to default for others.
 *
 * @internal
 */

/**
 * Handles the underlying data structure for a {@link Model} class.
 */
var Table = /*#__PURE__*/function () {
  return Table;
}();
/**
 * Type of {@link Model} state's branch `meta` field.
 */


exports.Table = Table;